<template>
  <div class="account container">
    <div class="box">
      <h1 class="title">Welcome {{account.username}}</h1>
      <div class="buttons">
        <b-button
         icon-left="plus"
         type="is-info"
         tag="router-link"
         :to="{ name: 'ModelAdd' }"
        >
        Add new model
        </b-button>
        <b-button
         icon-left="pencil"
         type="is-info"
         tag="router-link"
         :to="{ name: 'UserEdit', params: {user: account} }"
        >
        Change account details
        </b-button>

        <b-button
         v-if="account.role == 'ADMIN'"
         icon-left="cctv"
         type="is-info"
         tag="router-link"
         :to="{ name: 'Admin' }"
        >
        Admin panel
        </b-button>
      </div>
    </div>
    <div class="box">
      <h1 class="title is-4">My models</h1>
      <b-table :data="models" :loading="isLoading" striped hoverable>
        <template slot-scope="props">
          <b-table-column field="name" label="Model name" searchable sortable>
            {{ props.row.name }} <b-icon v-if="props.row.isVerified" icon="check"/>
          </b-table-column>

          <b-table-column field="vote" label="Votes" sortable>
            {{ props.row.votes }}
          </b-table-column>

          <b-table-column field="date" label="Last modification" centered sortable>
            {{ new Date(props.row.lastModified).toLocaleDateString() }}
          </b-table-column>

          <b-table-column field="date" label="Added" centered sortable>
            {{ new Date(props.row.added).toLocaleDateString() }}
          </b-table-column>

          <b-table-column label="" centered>
            <b-button class="actionButton" icon-left="eye" type="is-info" tag="router-link" :to="{ name: 'Model', query: { id: props.row.id } }" outlined/>
            <b-button class="actionButton" icon-left="pencil" type="is-warning" tag="router-link" :to="{ name: 'ModelEdit', params: {model: props.row} }" outlined/>
            <b-button class="actionButton" icon-left="delete" type="is-danger" @click="removePrompt(props.row.id, props.row.name)" outlined/>
          </b-table-column>
        </template>
      </b-table>
    </div>

    <div class="box">
      <h1 class="title is-4">Liked models</h1>
      <b-table :data="likedModels" :loading="isLoading" striped hoverable>
        <template slot-scope="props">
          <b-table-column field="name" label="Model name" searchable sortable>
            {{ props.row.name }} <b-icon v-if="props.row.isVerified" icon="check"/>
          </b-table-column>

          <b-table-column field="vote" label="Votes" sortable>
            {{ props.row.votes }}
          </b-table-column>

          <b-table-column field="date" label="Last modification" centered sortable>
            {{ new Date(props.row.lastModified).toLocaleDateString() }}
          </b-table-column>

          <b-table-column field="date" label="Added" centered sortable>
            {{ new Date(props.row.added).toLocaleDateString() }}
          </b-table-column>

          <b-table-column label="" centered>
            <b-button class="actionButton" icon-left="eye" type="is-info" tag="router-link" :to="{ name: 'Model', query: { id: props.row.id } }" outlined/>
          </b-table-column>
        </template>
      </b-table>
    </div>
  </div>
</template>

<script>
import { api } from '@/api.js'

export default {
  name: 'Account',
  data () {
    return {
      isLoading: true,
      account: {},
      models: [],
      likedModels: []
    }
  },
  async mounted () {
    this.account = await api.getUser()
    this.models = await api.getUserModels()
    this.likedModels = await api.getUserLikedModels()
    await localStorage.setItem('user_role', this.account.role)
    await localStorage.setItem('user_id', this.account.id)
    this.isLoading = false
  },
  methods: {
    removePrompt (id, name) {
      this.$buefy.dialog.confirm({
        message: 'Delete ' + name + ' ?',
        cancelText: 'Abort',
        confirmText: 'Delete',
        type: 'is-danger',
        hasIcon: true,
        onConfirm: async () => {
          await api.removeModel(id)
          this.$buefy.toast.open(name + ' deleted')
          this.models = await api.getUserModels()
        }
      })
    }
  }
}
</script>

<style scoped>
.account{
  margin-top: 20px;
}

.actionButton {
  margin-left:8px;
}
</style>
